/* A Bison parser, made from confparse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	INT	257
# define	FLOAT	258
# define	STRING	259
# define	ID	260
# define	FUNCTION	261
# define	RETURN	262
# define	VAR	263
# define	BIND	264
# define	SUBTREE	265
# define	RECURSIVE	266
# define	FINAL	267
# define	FALLBACK	268
# define	GLOBAL	269
# define	IF	270
# define	ELSE	271
# define	FOR	272
# define	WHILE	273
# define	NULLTOK	274
# define	T_INT	275
# define	T_FLOAT	276
# define	T_STRING	277
# define	T_ARRAY	278
# define	ASSIGN	279
# define	AUTOADD	280
# define	AUTOSUB	281
# define	LOGOR	282
# define	LOGAND	283
# define	EQ	284
# define	NE	285
# define	LT	286
# define	GT	287
# define	LE	288
# define	GE	289
# define	AUTOINC	290
# define	AUTODEC	291

#line 3 "confparse.y"

#include <malloc.h>
#include <stdlib.h>
#include <regex.h>
#include <string.h>

#include "command.h"
#include "lirccd.h"

#define YYERROR_VERBOSE

extern int yycurline;
extern unsigned char *yycurfile;

void yyerror(const char *err);

static struct instruction *pushnull(void)
{
    struct value *val;
    struct instruction *new;
    
    val = newval();
    new = inspush(val);
    relval(val);
    return(new);
}

static struct instruction *pusharraystart(void)
{
    struct value *val;
    struct instruction *new;
    
    (val = newval())->type = VAL_ARRAYSTART;
    new = inspush(val);
    relval(val);
    return(new);
}

static struct instruction *pushint(int num)
{
    struct value *val;
    struct instruction *new;
    
    val = valmakeint(newval(), num);
    new = inspush(val);
    relval(val);
    return(new);
}

static struct instruction *pushfloat(double num)
{
    struct value *val;
    struct instruction *new;
    
    val = newval();
    val->type = VAL_FLOAT;
    val->val.flnum = num;
    new = inspush(val);
    relval(val);
    return(new);
}

static struct instruction *pushstr(unsigned char *str)
{
    struct value *val;
    struct instruction *new;
    
    val = valmakestr(newval(), str);
    new = inspush(val);
    relval(val);
    return(new);
}


#line 78 "confparse.y"
#ifndef YYSTYPE
typedef union {
    int num;
    unsigned char *str;
    struct instruction *ins;
    struct binding *binding;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		167
#define	YYFLAG		-32768
#define	YYNTBASE	52

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 291 ? yytranslate[x] : 74)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    43,     2,     2,     2,     2,     2,     2,
      44,    45,    39,    37,    50,    38,     2,    40,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    51,
       2,    26,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    47,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    48,     2,    49,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      41,    42
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     5,     8,    11,    14,    19,    27,
      36,    38,    41,    43,    47,    49,    53,    55,    59,    65,
      72,    74,    78,    80,    82,    85,    87,    89,    91,    93,
      95,    99,   101,   104,   110,   118,   124,   134,   140,   142,
     146,   150,   152,   156,   158,   162,   166,   171,   175,   180,
     182,   184,   186,   188,   190,   192,   194,   198,   202,   206,
     210,   214,   218,   222,   226,   230,   234,   238,   242,   246,
     250,   253,   257,   261,   264,   267,   270,   273,   278,   282,
     287,   292,   297
};
static const short yyrhs[] =
{
      -1,    52,    60,     0,     0,    53,    13,     0,    53,    12,
       0,    53,    14,     0,    10,    53,     5,    61,     0,    10,
      53,     5,    11,    48,    55,    49,     0,    10,    53,     5,
      11,    48,    61,    55,    49,     0,    54,     0,    55,    54,
       0,     6,     0,     6,    26,    73,     0,    56,     0,    57,
      50,    56,     0,     6,     0,    58,    50,     6,     0,     7,
       6,    44,    45,    61,     0,     7,     6,    44,    58,    45,
      61,     0,    59,     0,    15,    57,    51,     0,    54,     0,
      51,     0,    73,    51,     0,    63,     0,    64,     0,    65,
       0,    66,     0,    68,     0,    48,    62,    49,     0,    61,
       0,    62,    61,     0,    16,    44,    73,    45,    61,     0,
      16,    44,    73,    45,    61,    17,    61,     0,    19,    44,
      73,    45,    61,     0,    18,    44,    73,    51,    73,    51,
      73,    45,    61,     0,     8,    44,    73,    45,    51,     0,
       6,     0,    67,    50,     6,     0,     9,    67,    51,     0,
      73,     0,    69,    50,    73,     0,    73,     0,    70,    50,
      73,     0,     6,    44,    45,     0,     6,    44,    69,    45,
       0,    24,    44,    45,     0,    24,    44,    70,    45,     0,
      20,     0,     3,     0,     4,     0,     5,     0,     6,     0,
      72,     0,    71,     0,    73,    37,    73,     0,    73,    38,
      73,     0,    73,    39,    73,     0,    73,    40,    73,     0,
      73,    26,    73,     0,    73,    25,     6,     0,    73,    27,
      73,     0,    73,    28,    73,     0,    73,    31,    73,     0,
      73,    32,    73,     0,    73,    34,    73,     0,    73,    33,
      73,     0,    73,    36,    73,     0,    73,    35,    73,     0,
      43,    73,     0,    73,    29,    73,     0,    73,    30,    73,
       0,    41,    73,     0,    42,    73,     0,    73,    41,     0,
      73,    42,     0,    73,    46,    73,    47,     0,    44,    73,
      45,     0,    44,    21,    45,    73,     0,    44,    22,    45,
      73,     0,    44,    23,    45,    73,     0,    44,    24,    45,
      73,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   130,   130,   132,   133,   134,   135,   138,   151,   164,
     179,   180,   187,   195,   208,   209,   212,   223,   237,   246,
     260,   261,   262,   265,   266,   267,   268,   269,   270,   271,
     272,   275,   276,   279,   292,   310,   328,   350,   358,   359,
     362,   364,   365,   368,   369,   372,   385,   401,   408,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   455,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "FLOAT", "STRING", "ID", "FUNCTION", 
  "RETURN", "VAR", "BIND", "SUBTREE", "RECURSIVE", "FINAL", "FALLBACK", 
  "GLOBAL", "IF", "ELSE", "FOR", "WHILE", "NULLTOK", "T_INT", "T_FLOAT", 
  "T_STRING", "T_ARRAY", "ASSIGN", "'='", "AUTOADD", "AUTOSUB", "LOGOR", 
  "LOGAND", "EQ", "NE", "LT", "GT", "LE", "GE", "'+'", "'-'", "'*'", 
  "'/'", "AUTOINC", "AUTODEC", "'!'", "'('", "')'", "'['", "']'", "'{'", 
  "'}'", "','", "';'", "file", "bindflags", "binding", "bindings", 
  "globaldecl", "varlist", "declarglist", "functiondecl", "directive", 
  "stmt", "multistmt", "ifstmt", "whilestmt", "forstmt", "returnstmt", 
  "lvarlist", "varstmt", "arglist", "invarglist", "call", "makearray", 
  "expr", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    52,    52,    53,    53,    53,    53,    54,    54,    54,
      55,    55,    56,    56,    57,    57,    58,    58,    59,    59,
      60,    60,    60,    61,    61,    61,    61,    61,    61,    61,
      61,    62,    62,    63,    63,    64,    65,    66,    67,    67,
      68,    69,    69,    70,    70,    71,    71,    72,    72,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     0,     2,     2,     2,     4,     7,     8,
       1,     2,     1,     3,     1,     3,     1,     3,     5,     6,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     7,     5,     9,     5,     1,     3,
       3,     1,     3,     1,     3,     3,     4,     3,     4,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     2,     2,     2,     2,     4,     3,     4,
       4,     4,     4
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     0,     3,     0,    22,    20,     2,     0,     0,
      12,    14,     0,     0,     0,     5,     4,     6,     0,     0,
      21,    16,     0,     0,    50,    51,    52,    53,     0,     0,
       0,     0,     0,     0,    49,     0,     0,     0,     0,     0,
       0,    23,     7,    25,    26,    27,    28,    29,    55,    54,
       0,    13,    15,    18,     0,     0,     0,     0,    38,     0,
       0,     0,     0,     0,     0,    73,    74,    70,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    75,    76,     0,    24,    19,    17,    45,     0,    41,
       0,     0,    40,    10,     0,     0,     0,     0,     0,    47,
       0,    43,     0,     0,     0,     0,    78,    30,    32,    61,
      60,    62,    63,    71,    72,    64,    65,    67,    66,    69,
      68,    56,    57,    58,    59,     0,    46,     0,     0,    39,
       8,    11,     0,     0,     0,     0,    48,     0,    79,    80,
      81,    82,    77,    42,    37,     9,    33,     0,    35,    44,
       0,     0,    34,     0,     0,    36,     0,     0
};

static const short yydefgoto[] =
{
       1,     9,   103,   104,    11,    12,    23,     6,     7,    42,
      74,    43,    44,    45,    46,    59,    47,    98,   110,    48,
      49,    50
};

static const short yypact[] =
{
  -32768,    74,     2,-32768,    10,-32768,-32768,-32768,   -17,    78,
      11,-32768,   -46,    -4,     6,-32768,-32768,-32768,   291,    10,
  -32768,-32768,   210,   -22,-32768,-32768,-32768,   -15,     7,    47,
       8,    32,    42,    44,-32768,    66,   291,   291,   291,   266,
     210,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     311,   525,-32768,-32768,   210,    73,   235,   291,-32768,   -44,
     112,   291,   291,   291,   240,    36,    36,    36,    69,    79,
      80,    58,   415,-32768,   161,   106,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   291,   291,   291,   291,
     291,-32768,-32768,   291,-32768,-32768,-32768,-32768,    35,   525,
     437,   117,-32768,-32768,    -7,   123,   459,   338,   481,-32768,
      61,   525,   291,   291,   291,   291,-32768,-32768,-32768,-32768,
     546,   546,   546,   563,   285,   578,   592,   605,   617,   150,
      -6,    59,    59,    67,    67,   392,-32768,   291,    76,-32768,
  -32768,-32768,     3,   210,   291,   210,-32768,   291,    88,    88,
      88,    88,-32768,   525,-32768,-32768,   118,   365,-32768,   525,
     210,   291,-32768,   503,   210,-32768,   137,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,     0,    34,   119,-32768,-32768,-32768,-32768,    33,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   -18
};


#define	YYLAST		663


static const short yytable[] =
{
      51,     5,    21,     3,    19,    20,   101,   102,     8,    24,
      25,    26,    27,     3,    28,    29,    10,    30,    65,    66,
      67,    72,    31,    54,    32,    33,    34,    13,    55,    56,
      35,    87,    88,    89,    90,    91,    92,    18,    99,   100,
      93,    22,   140,   106,   107,   108,   111,    36,    37,    38,
      39,    57,   155,    58,    40,    53,    60,    41,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,    73,   166,   135,    61,-32768,-32768,    96,
     136,     2,    93,    14,     3,   137,    62,    95,    63,     4,
      15,    16,    17,   105,   148,   149,   150,   151,    89,    90,
      91,    92,    64,   115,   141,    93,   146,   118,    91,    92,
      64,   147,   119,    93,   112,    24,    25,    26,    27,   153,
      28,    29,     3,   139,   113,   114,   157,   154,    31,   159,
      32,    33,    34,     3,-32768,   160,    35,   167,    52,   142,
       0,     0,   141,   163,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,    37,    38,    39,     0,     0,     0,
      40,     0,     0,    41,    24,    25,    26,    27,     0,    28,
      29,     0,     0,     0,     0,     0,   156,    31,   158,    32,
      33,    34,     0,     0,     0,    35,    86,    87,    88,    89,
      90,    91,    92,   162,     0,     0,    93,   165,     0,     0,
       0,     0,    36,    37,    38,    39,     0,     0,     0,    40,
     117,     0,    41,    24,    25,    26,    27,     0,    28,    29,
       0,     0,     0,     0,     0,     0,    31,     0,    32,    33,
      34,     0,     0,     0,    35,     0,     0,     0,    24,    25,
      26,    27,     0,    24,    25,    26,    27,     0,     0,     0,
       0,    36,    37,    38,    39,    34,     0,     0,    40,    35,
      34,    41,     0,     0,    35,     0,     0,     0,     0,    24,
      25,    26,    27,     0,     0,     0,    36,    37,    38,    39,
      97,    36,    37,    38,    39,   109,    34,    68,    69,    70,
      71,     0,     0,     0,    24,    25,    26,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    37,    38,
      39,    34,     0,     0,     0,    35,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
       0,    93,    36,    37,    38,    39,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,     0,     0,     0,    93,     0,     0,
       0,     0,    94,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,     0,     0,     0,    93,     0,     0,     0,     0,   144,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
       0,    93,     0,     0,     0,     0,   161,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,     0,     0,     0,    93,   152,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
     116,    93,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
       0,     0,   138,    93,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,     0,     0,   143,    93,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,     0,     0,   145,    93,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,     0,     0,   164,    93,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
       0,    93,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,     0,
       0,     0,    93,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,     0,     0,     0,    93,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,     0,     0,     0,    93,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,     0,     0,     0,    93,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,     0,
       0,    93,    85,    86,    87,    88,    89,    90,    91,    92,
       0,     0,     0,    93
};

static const short yycheck[] =
{
      18,     1,     6,    10,    50,    51,    50,    51,     6,     3,
       4,     5,     6,    10,     8,     9,     6,    11,    36,    37,
      38,    39,    16,    45,    18,    19,    20,    44,    50,    44,
      24,    37,    38,    39,    40,    41,    42,    26,    56,    57,
      46,    45,    49,    61,    62,    63,    64,    41,    42,    43,
      44,    44,    49,     6,    48,    22,    48,    51,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    40,     0,    93,    44,    41,    42,     6,
      45,     7,    46,     5,    10,    50,    44,    54,    44,    15,
      12,    13,    14,    60,   112,   113,   114,   115,    39,    40,
      41,    42,    44,    45,   104,    46,    45,    74,    41,    42,
      44,    50,     6,    46,    45,     3,     4,     5,     6,   137,
       8,     9,    10,     6,    45,    45,   144,    51,    16,   147,
      18,    19,    20,    10,    46,    17,    24,     0,    19,   105,
      -1,    -1,   142,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    -1,    -1,    51,     3,     4,     5,     6,    -1,     8,
       9,    -1,    -1,    -1,    -1,    -1,   143,    16,   145,    18,
      19,    20,    -1,    -1,    -1,    24,    36,    37,    38,    39,
      40,    41,    42,   160,    -1,    -1,    46,   164,    -1,    -1,
      -1,    -1,    41,    42,    43,    44,    -1,    -1,    -1,    48,
      49,    -1,    51,     3,     4,     5,     6,    -1,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    18,    19,
      20,    -1,    -1,    -1,    24,    -1,    -1,    -1,     3,     4,
       5,     6,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
      -1,    41,    42,    43,    44,    20,    -1,    -1,    48,    24,
      20,    51,    -1,    -1,    24,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,    -1,    -1,    -1,    41,    42,    43,    44,
      45,    41,    42,    43,    44,    45,    20,    21,    22,    23,
      24,    -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,
      44,    20,    -1,    -1,    -1,    24,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    46,    41,    42,    43,    44,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    51,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    51,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    51,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    -1,    -1,    -1,    46,    47,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      45,    46,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      -1,    -1,    45,    46,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    -1,    -1,    45,    46,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    -1,    -1,    45,    46,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,    -1,    45,    46,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    46,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    -1,
      -1,    -1,    46,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,    -1,    -1,    46,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    46,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    -1,    -1,    -1,    46,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      -1,    46,    35,    36,    37,    38,    39,    40,    41,    42,
      -1,    -1,    -1,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 132 "confparse.y"
{yyval.num = 0;}
    break;
case 4:
#line 133 "confparse.y"
{yyval.num = yyvsp[-1].num | BIND_STOP;}
    break;
case 5:
#line 134 "confparse.y"
{yyval.num = yyvsp[-1].num | BIND_RECURSIVE;}
    break;
case 6:
#line 135 "confparse.y"
{yyval.num = yyvsp[-1].num | BIND_FALLBACK;}
    break;
case 7:
#line 139 "confparse.y"
{
		    unsigned char *p;
		    if((p = strchr(yyvsp[-1].str, ':')) == NULL)
		    {
			yyval.binding = newbinding(".*", yyvsp[-1].str, yyvsp[0].ins);
		    } else {
			*(p++) = 0;
			yyval.binding = newbinding(yyvsp[-1].str, p, yyvsp[0].ins);
		    }
		    yyval.binding->flags = yyvsp[-2].num;
		    free(yyvsp[-1].str);
		}
    break;
case 8:
#line 152 "confparse.y"
{
		    unsigned char *p;
		    if((p = strchr(yyvsp[-4].str, ':')) == NULL)
		    {
			yyval.binding = newbinding(".*", yyvsp[-4].str, NULL);
		    } else {
			*(p++) = 0;
			yyval.binding = newbinding(yyvsp[-4].str, p, NULL);
		    }
		    addbinding(&yyval.binding->child, yyvsp[-1].binding);
		    free(yyvsp[-4].str);
		}
    break;
case 9:
#line 165 "confparse.y"
{
		    unsigned char *p;
		    if((p = strchr(yyvsp[-5].str, ':')) == NULL)
		    {
			yyval.binding = newbinding(".*", yyvsp[-5].str, yyvsp[-2].ins);
		    } else {
			*(p++) = 0;
			yyval.binding = newbinding(yyvsp[-5].str, p, yyvsp[-2].ins);
		    }
		    addbinding(&yyval.binding->child, yyvsp[-1].binding);
		    free(yyvsp[-5].str);
		}
    break;
case 10:
#line 179 "confparse.y"
{yyval.binding = yyvsp[0].binding;}
    break;
case 11:
#line 181 "confparse.y"
{
		    addbinding(&yyvsp[-1].binding, yyvsp[0].binding);
		    yyval.binding = yyvsp[-1].binding;
		}
    break;
case 12:
#line 188 "confparse.y"
{
		    struct value *val;
		    val = newval();
		    newsym(yyvsp[0].str, val);
		    relval(val);
		    free(yyvsp[0].str);
		}
    break;
case 13:
#line 196 "confparse.y"
{
		    struct value *val;
		    run(yyvsp[0].ins);
		    freecode(yyvsp[0].ins);
		    val = pop();
		    checkstack();
		    newsym(yyvsp[-2].str, val);
		    relval(val);
		    free(yyvsp[-2].str);
		}
    break;
case 16:
#line 213 "confparse.y"
{
		    yyval.ins = insconcat(
			pushstr(yyvsp[0].str),
			insmake("MAKEVAR"),
			insmake("SWAP"),
			insmake("STORE"),
			insmake("DROP"),
			NULL);
		    free(yyvsp[0].str);
		}
    break;
case 17:
#line 224 "confparse.y"
{
		    yyval.ins = insconcat(
			pushstr(yyvsp[0].str),
			insmake("MAKEVAR"),
			insmake("SWAP"),
			insmake("STORE"),
			insmake("DROP"),
			yyvsp[-2].ins,
			NULL);
		    free(yyvsp[0].str);
		}
    break;
case 18:
#line 238 "confparse.y"
{
		    newfunc(yyvsp[-3].str, insconcat(
				yyvsp[0].ins,
				pushnull(),
				insmake("RETURN"),
				NULL));
		    free(yyvsp[-3].str);
		}
    break;
case 19:
#line 247 "confparse.y"
{
		    newfunc(yyvsp[-4].str, insconcat(
				insmake("BEGINSCOPE"),
				yyvsp[-2].ins,
				yyvsp[0].ins,
				pushnull(),
				insmake("ENDSCOPE"),
				insmake("RETURN"),
				NULL));
		    free(yyvsp[-4].str);
		}
    break;
case 22:
#line 262 "confparse.y"
{addbinding(&bindings, yyvsp[0].binding);}
    break;
case 23:
#line 265 "confparse.y"
{yyval.ins = insmake("NOOP");}
    break;
case 24:
#line 266 "confparse.y"
{yyval.ins = insconcat(yyvsp[-1].ins, insmake("DROP"), NULL);}
    break;
case 25:
#line 267 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 26:
#line 268 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 27:
#line 269 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 28:
#line 270 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 29:
#line 271 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 30:
#line 272 "confparse.y"
{yyval.ins = insconcat(insmake("BEGINSCOPE"), yyvsp[-1].ins, insmake("ENDSCOPE"), NULL);}
    break;
case 31:
#line 275 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 32:
#line 276 "confparse.y"
{yyval.ins = insconcat(yyvsp[-1].ins, yyvsp[0].ins, NULL);}
    break;
case 33:
#line 280 "confparse.y"
{struct instruction *ins;
	ins = insmake("NOOP");
	yyval.ins = insconcat(
	    yyvsp[-2].ins,
	    insmake("NOT"),
	    pushint(label(ins)),
	    insmake("SWAP"),
	    insmake("CJUMP"),
	    yyvsp[0].ins,
	    ins,
	    NULL);
	}
    break;
case 34:
#line 293 "confparse.y"
{struct instruction *ins;
	ins = insmake("NOOP");
	yyval.ins = insconcat(
	    yyvsp[-4].ins,
	    insmake("NOT"),
	    pushint(label(yyvsp[0].ins)),
	    insmake("SWAP"),
	    insmake("CJUMP"),
	    yyvsp[-2].ins,
	    pushint(label(ins)),
	    insmake("JUMP"),
	    yyvsp[0].ins,
	    ins,
	    NULL);
	}
    break;
case 35:
#line 311 "confparse.y"
{struct instruction *ins;
	int lab;
	ins = insmake("NOOP");
	lab = label(yyvsp[-2].ins);
	yyval.ins = insconcat(
	    yyvsp[-2].ins,
	    insmake("NOT"),
	    pushint(label(ins)),
	    insmake("SWAP"),
	    insmake("CJUMP"),
	    yyvsp[0].ins,
	    pushint(lab),
	    insmake("JUMP"),
	    ins,
	    NULL);
	}
    break;
case 36:
#line 329 "confparse.y"
{struct instruction *ins;
	int lab;
	ins = insmake("NOOP");
	lab = label(yyvsp[-4].ins);
	yyval.ins = insconcat(
	    yyvsp[-6].ins,
	    insmake("DROP"),
	    yyvsp[-4].ins,
	    insmake("NOT"),
	    pushint(label(ins)),
	    insmake("SWAP"),
	    insmake("CJUMP"),
	    yyvsp[0].ins,
	    yyvsp[-2].ins,
	    insmake("DROP"),
	    pushint(lab),
	    insmake("JUMP"),
	    ins,
	    NULL);
	}
    break;
case 37:
#line 351 "confparse.y"
{
	    yyval.ins = insconcat(
		yyvsp[-2].ins,
		insmake("RETURN"),
		NULL);
	}
    break;
case 38:
#line 358 "confparse.y"
{yyval.ins = insconcat(pushstr(yyvsp[0].str), insmake("MAKEVAR"), insmake("DROP"), NULL); free(yyvsp[0].str);}
    break;
case 39:
#line 359 "confparse.y"
{yyval.ins = insconcat(pushstr(yyvsp[0].str), insmake("MAKEVAR"), insmake("DROP"), NULL); free(yyvsp[0].str);}
    break;
case 40:
#line 362 "confparse.y"
{yyval.ins = yyvsp[-1].ins;}
    break;
case 41:
#line 364 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 42:
#line 365 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, NULL);}
    break;
case 43:
#line 368 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 44:
#line 369 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, yyvsp[-2].ins, NULL);}
    break;
case 45:
#line 373 "confparse.y"
{
	    if(findcommand(yyvsp[-2].str) != NULL)
	    {
		yyval.ins = insmake(yyvsp[-2].str);
	    } else {
		yyval.ins = insconcat(
		    pushstr(yyvsp[-2].str),
		    insmake("CALL"),
		    NULL);
	    }
	    free(yyvsp[-2].str);
	}
    break;
case 46:
#line 386 "confparse.y"
{
	    if(findcommand(yyvsp[-3].str) != NULL)
	    {
		yyval.ins = insconcat(yyvsp[-1].ins, insmake(yyvsp[-3].str), NULL);
	    } else {
		yyval.ins = insconcat(
		    yyvsp[-1].ins,
		    pushstr(yyvsp[-3].str),
		    insmake("CALL"),
		    NULL);
	    }
	    free(yyvsp[-3].str);
	}
    break;
case 47:
#line 402 "confparse.y"
{
		    yyval.ins = insconcat(
			pusharraystart(),
			insmake("ARRAY"),
			NULL);
		}
    break;
case 48:
#line 409 "confparse.y"
{
		    yyval.ins = insconcat(
			pusharraystart(),
			yyvsp[-1].ins,
			insmake("ARRAY"),
			NULL);
		}
    break;
case 49:
#line 418 "confparse.y"
{yyval.ins = pushnull();}
    break;
case 50:
#line 419 "confparse.y"
{yyval.ins = pushint(atoi(yyvsp[0].str)); free(yyvsp[0].str);}
    break;
case 51:
#line 420 "confparse.y"
{yyval.ins = pushfloat(atof(yyvsp[0].str)); free(yyvsp[0].str);}
    break;
case 52:
#line 421 "confparse.y"
{yyval.ins = pushstr(yyvsp[0].str); free(yyvsp[0].str);}
    break;
case 53:
#line 422 "confparse.y"
{yyval.ins = insconcat(pushstr(yyvsp[0].str), insmake("LOAD"), NULL); free(yyvsp[0].str);}
    break;
case 54:
#line 423 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 55:
#line 424 "confparse.y"
{yyval.ins = yyvsp[0].ins;}
    break;
case 56:
#line 425 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("ADD"), NULL);}
    break;
case 57:
#line 426 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("SUB"), NULL);}
    break;
case 58:
#line 427 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("MUL"), NULL);}
    break;
case 59:
#line 428 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("DIV"), NULL);}
    break;
case 60:
#line 429 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("STORE"), NULL);}
    break;
case 61:
#line 430 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, pushstr(yyvsp[0].str), insmake("ASSIGN"), NULL);}
    break;
case 62:
#line 431 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, insmake("DUP"), yyvsp[0].ins, insmake("ADD"), insmake("STORE"), NULL);}
    break;
case 63:
#line 432 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, insmake("DUP"), yyvsp[0].ins, insmake("SUB"), insmake("STORE"), NULL);}
    break;
case 64:
#line 433 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("EQ"), NULL);}
    break;
case 65:
#line 434 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("NE"), NULL);}
    break;
case 66:
#line 435 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("GT"), NULL);}
    break;
case 67:
#line 436 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("LT"), NULL);}
    break;
case 68:
#line 437 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("GE"), NULL);}
    break;
case 69:
#line 438 "confparse.y"
{yyval.ins = insconcat(yyvsp[-2].ins, yyvsp[0].ins, insmake("LE"), NULL);}
    break;
case 70:
#line 439 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("NOT"), NULL);}
    break;
case 71:
#line 441 "confparse.y"
{
	    struct instruction *ins;
	    ins = insmake("NOOP");
	    yyval.ins = insconcat(
		yyvsp[-2].ins,
		insmake("DUP"),
		pushint(label(ins)),
		insmake("SWAP"),
		insmake("CJUMP"),
		insmake("DROP"),
		yyvsp[0].ins,
		ins,
		NULL);
	}
    break;
case 72:
#line 456 "confparse.y"
{
	    struct instruction *ins;
	    ins = insmake("NOOP");
	    yyval.ins = insconcat(
		yyvsp[-2].ins,
		insmake("DUP"),
		insmake("NOT"),
		pushint(label(ins)),
		insmake("SWAP"),
		insmake("CJUMP"),
		insmake("DROP"),
		yyvsp[0].ins,
		ins,
		NULL);
	}
    break;
case 73:
#line 471 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("INC"), NULL);}
    break;
case 74:
#line 472 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("DEC"), NULL);}
    break;
case 75:
#line 473 "confparse.y"
{yyval.ins = insconcat(yyvsp[-1].ins, insmake("DUP"), insmake("SWAP"), insmake("INC"), insmake("DROP"), NULL);}
    break;
case 76:
#line 474 "confparse.y"
{yyval.ins = insconcat(yyvsp[-1].ins, insmake("DUP"), insmake("SWAP"), insmake("DEC"), insmake("DROP"), NULL);}
    break;
case 77:
#line 475 "confparse.y"
{yyval.ins = insconcat(yyvsp[-3].ins, yyvsp[-1].ins, insmake("INDEX"), NULL);}
    break;
case 78:
#line 476 "confparse.y"
{yyval.ins = yyvsp[-1].ins;}
    break;
case 79:
#line 477 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("MAKEINT"), NULL);}
    break;
case 80:
#line 478 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("MAKEFLOAT"), NULL);}
    break;
case 81:
#line 479 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("MAKESTRING"), NULL);}
    break;
case 82:
#line 480 "confparse.y"
{yyval.ins = insconcat(yyvsp[0].ins, insmake("MAKEARRAY"), NULL);}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 483 "confparse.y"


void yyerror(const char *err)
{
    printf("%i in %s: %s\n", yycurline, yycurfile, err);
    exit(1);
}
